var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _class, _temp;

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _objectDestructuringEmpty(obj) { if (obj == null) throw new TypeError("Cannot destructure undefined"); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

// import styles from './styles/styles.less';
// import styles2 from 'react-big-calendar/lib/addons/dragAndDrop/styles.less';
// import styles from './styles/styles.css';
// import styles2 from 'react-big-calendar/lib/css/react-big-calendar.css';

import React, { Component } from 'react';

import PropTypes from 'prop-types';

import BigCalendar from 'react-big-calendar';

import HTML5Backend from 'react-dnd-html5-backend';
import { DragDropContext } from 'react-dnd';
import withDragAndDrop from 'react-big-calendar/lib/addons/dragAndDrop';
// import 'react-big-calendar/lib/addons/dragAndDrop/styles.less';

import moment from 'moment';
// import locale from 'moment/src/locale/ru';

if (typeof window !== "undefined") {
	window.moment = moment;
}

// console.log('styles', styles);
// console.log('styles2', styles2);

var _require = require('react-big-calendar/lib/utils/messages'),
    messages = _require.default;

messages = messages({
	allDay: "Весь день"
});
// console.log('messages', messages);


// require('globalize/lib/cultures/globalize.culture.ru');

BigCalendar.setLocalizer(BigCalendar.momentLocalizer(moment));

var DragAndDropCalendar = withDragAndDrop(BigCalendar);

var allViews = Object.keys(BigCalendar.Views).map(function (k) {
	return BigCalendar.Views[k];
});
// allViews = allViews.filter(n => n === "week");


export var objectToDate = function objectToDate(object, toArray) {
	var _object = object,
	    start = _object.start,
	    end = _object.end;


	object = Object.assign({}, object, {
		start: toDate(start, toArray),
		end: toDate(end, toArray)
	});

	return object;
};

export var toDate = function toDate(array, toArray) {

	if (!array) {
		return null;
	}

	var year = array.year,
	    month = array.month,
	    day = array.day,
	    hour = array.hour,
	    minute = array.minute,
	    second = array.second,
	    weekDay = array.weekDay;


	var date = moment().startOf('week');

	date.add("day", weekDay);
	date.set("hour", hour);
	date.set("minute", minute);
	date.set("second", second);

	if (toArray) {
		date = date.toDate();
	}

	return date;
};

export var ReactSchedule = (_temp = _class = function (_Component) {
	_inherits(ReactSchedule, _Component);

	function ReactSchedule(props) {
		_classCallCheck(this, ReactSchedule);

		var _this = _possibleConstructorReturn(this, _Component.call(this, props));

		_objectDestructuringEmpty(props);

		_this.state = {
			// days,
			currentDate: moment()
		};
		return _this;
	}

	ReactSchedule.prototype.onSelect = function onSelect(event) {

		if (window.confirm("Удалить этот элемент?")) {

			// console.log("onSelect event", event);
			// console.log("onSelect b", b);
			// console.log("onSelect c", c);

			// let {
			// 	days,
			// } = this.state;

			var days = this.props.days;
			var start = event.start;


			if (!start) {
				return false;
			}

			var day = moment(start).weekday();

			// const index = days && days.indexOf(event);

			// console.log("event index", index);

			// console.log("event days", day, days);

			var index = days.findIndex(function (n) {
				return n && n.start && n.start.weekDay === day;
			});

			if (index !== -1) {

				days[index] = null;
			}

			// console.log("event days", day, days);

			// this.setState({
			// 	days,
			// });

			this.onChange(days);
		}
	};

	ReactSchedule.prototype.onSelectSlot = function onSelectSlot(slotInfo) {
		// console.log(
		// 	slotInfo,

		//    `selected slot: \n\nstart ${slotInfo.start.toLocaleString()} ` +
		//    `\nend: ${slotInfo.end.toLocaleString()}` +
		//    `\naction: ${slotInfo.action}`
		//  );

		var start = slotInfo.start,
		    end = slotInfo.end,
		    action = slotInfo.action;

		// let {
		// 	days,
		// } = this.state;

		var days = this.props.days;


		start = moment(start);
		end = moment(end);

		var dayIndex = start.weekday();

		var prevDate = days && days[dayIndex];

		var prevDateObject = prevDate && objectToDate(prevDate);

		var yesderday = void 0;

		// console.log('onSelectSlot start', start, moment(start).weekday());


		// let startHour = start.get('hour');
		// let startMinute = start.get('minute');

		// let endHour = end.get('hour');
		// let endMinute = end.get('minute');

		// console.log("newEvent", newEvent);

		// Получаем предыдущую информацию за этот день, если она была,
		// то добавляем время к предыдущему таймеру

		switch (action) {

			case 'click':

				if (!prevDate || prevDateObject && prevDateObject.start && prevDateObject.start > start) {

					yesderday = days && days[dayIndex - 1];

					if (yesderday) {

						prevDate = yesderday;
					}
				}

				if (prevDate) {

					// console.log('prevDate', prevDate);

					prevDate = objectToDate(prevDate);

					// console.log('prevDate', prevDate);

					var _prevDate = prevDate,
					    prevStart = _prevDate.start,
					    prevEnd = _prevDate.end;

					// Если предыдущий день 

					if (start > prevEnd
					// Если длительность не более суток
					&& end - prevStart < 24 * 60 * 60 * 1000
					// Если не отметка за сутки
					&& !(start.get("hour") === end.get("hour") && start.get("minute") === end.get("minute"))) {
						start = prevStart;

						if (yesderday) {

							dayIndex--;
						}
					}

					// const {
					// 	start: prevStart,
					// 	end: prevEnd,
					// } = prevDate;

					// const {
					// 	hour: prevStartHour,
					// 	minute: prevStartMinute,
					// } = prevStart || {};

					// const {
					// 	hour: prevEndHour,
					// 	minute: prevEndMinute,
					// } = prevEnd || {};


					// if(prevStartHour !== undefined){

					// 	if(prevStartHour * 60 + prevStartMinute < startHour * 60 + prevEndMinute){
					// 		startHour = prevStartHour;
					// 		startMinute = prevStartMinute;
					// 	}

					// }
				}

				break;

		}

		// let startArray = start && start.toArray();

		var newStart = void 0;

		if (start) {
			var _start$toArray = _extends({}, start.toArray()),
			    year = _start$toArray[0],
			    month = _start$toArray[1],
			    day = _start$toArray[2],
			    hour = _start$toArray[3],
			    minute = _start$toArray[4],
			    second = _start$toArray[5];

			newStart = {
				year: year,
				month: month,
				day: day,
				hour: hour,
				minute: minute,
				second: second,
				weekDay: start.weekday()
			};
		}

		var newEnd = void 0;

		if (end) {
			var _end$toArray = _extends({}, end.toArray()),
			    _year = _end$toArray[0],
			    _month = _end$toArray[1],
			    _day = _end$toArray[2],
			    _hour = _end$toArray[3],
			    _minute = _end$toArray[4],
			    _second = _end$toArray[5];

			newEnd = {
				year: _year,
				month: _month,
				day: _day,
				hour: _hour,
				minute: _minute,
				second: _second,
				weekDay: end.weekday()
			};
		}

		var newEvent = {
			start: newStart,
			end: newEnd
		};

		// Устанавливаем данные дня
		days[dayIndex] = newEvent;

		// console.log('days', days);

		this.onChange(days);
	};

	ReactSchedule.prototype.onChange = function onChange(days) {
		var onChange = this.props.onChange;


		onChange && onChange(days);

		// this.setState({
		// 	days,
		// });
	};

	ReactSchedule.prototype.moveEvent = function moveEvent(event) {
		// const { events } = this.state;

		// const { start, end } = event;

		// console.log('moveEvent', event, start, end);

		// const idx = events.indexOf(event);
		// const updatedEvent = { ...event, start, end };

		// Object.assign(event, {
		// 	start,
		// 	end,
		// });

		// const nextEvents = [...events]
		// nextEvents.splice(idx, 1, updatedEvent)

		// this.setState({
		//   // events: nextEvents
		//   events,
		// })

		// console.log(`${event.title} was dropped onto ${event.start}`);

		// this.forceUpdate();


		this.onSelectSlot(event);
	};

	ReactSchedule.prototype.render = function render() {
		var _this2 = this;

		var _props = this.props,
		    days = _props.days,
		    other = _objectWithoutProperties(_props, ['days']);

		var currentDate = this.state.currentDate;


		var events = [];

		// console.log("currentDate", currentDate);

		// Формируем дни недели

		var startDay = currentDate.clone().startOf('week');

		days.map(function (n, index) {
			// events.push(day);

			if (!n) {
				return;
			}

			// const {
			// 	start,
			// 	end,
			// } = n;

			// if(!start || !end){
			// 	return;
			// }

			// const {
			// 	hour: startHour,
			// 	minute: startMinute,
			// } = start;

			// const {
			// 	hour: endHour,
			// 	minute: endMinute,
			// } = end;

			// // console.log("days n", n);

			// let newData = startDay.clone().add('day', index);
			// let newStart = newData.clone().add('hour', startHour).add('minute', startMinute);
			// let newEnd = newData.clone().add('hour', endHour).add('minute', endMinute);

			// // newStart = newStart.toArray();
			// // newStart[6] = 0;

			// // newEnd = newEnd.toArray();
			// // newEnd[6] = 0;

			// // let event = {
			// // 	start: new Date(newStart),
			// // 	end: new Date(newEnd),
			// // };

			// let event = {
			// 	start: newStart.toDate(),
			// 	end: newEnd.toDate(),
			// 	allDay: false,
			// };

			// console.log('event', n);

			var event = objectToDate(n, true);

			events.push(event);

			// console.log('event', event, moment(newStart).toArray(), moment(newEnd).toArray());
		});

		// console.log('events', events);

		// events.push({
		// 	title: "SDfsdf",
		//    'start': moment(new Date(2017, 10, 12, 7,0,0)).toDate(),
		//    'end': moment(new Date(2017, 10, 12, 17,0,0)).toDate(),
		//  });


		return React.createElement(DragAndDropCalendar, _extends({
			selectable: true,
			toolbar: false,
			events: events,
			views: allViews,
			defaultView: 'week'
			// view="month"
			, step: 30,
			defaultDate: currentDate,
			culture: 'ru',
			onSelectEvent: function onSelectEvent(event) {
				return _this2.onSelect(event);
			},
			onSelectSlot: function onSelectSlot(slotInfo) {
				return _this2.onSelectSlot(slotInfo);
			},
			onEventDrop: function onEventDrop(event) {
				return _this2.moveEvent(event);
			}
			// allDayAccessor="Весь день"
			, messages: messages,
			showMultiDayTimes: true
			// onDrillDown={() => {
			// 	console.log("onDrillDown");
			// }}
			, formats: {
				dayFormat: "dddd"
			}
		}, other));
	};

	return ReactSchedule;
}(Component), _class.defaultProps = {
	days: []
}, _class.contextTypes = {}, _temp);

ReactSchedule.propTypes = process.env.NODE_ENV !== "production" ? {
	days: PropTypes.array,
	onChange: PropTypes.func
} : {};
export default DragDropContext(HTML5Backend)(ReactSchedule);